package pps.core.base.service;

import cn.hutool.core.io.FileUtil;
import com.alibaba.excel.EasyExcel;
import pps.core.base.excel.ThirdApiWeatherDataListener;
import pps.core.base.excel.ThirdApiWeatherDataListener2;
import pps.core.base.excel.WindPredictionDataListener;
import pps.core.base.excel.WindPredictionDataListener2;
import pps.core.base.service.data.base_data.GetBaseDataInput;
import pps.core.base.service.data.base_excel.WindPredictionExcel2Data;
import pps.core.base.service.data.base_excel.WindPredictionExcelData;
import pps.core.base.service.data.base_power_line.DynamicQueryBasePowerLineInput;
import pps.core.base.service.data.base_power_line.DynamicQueryBasePowerLineOutput;
import pps.core.base.service.data.third_weather_data.ThirdApiWeatherExcelData;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.data.XListResult;
import xstartup.data.XServiceResult;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;

import java.io.File;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@XService
public class BaseLineService {

    @XText("线路列表")
    @XApiPost
    public XListResult<DynamicQueryBasePowerLineOutput> queryBaseLineList(XContext context, DynamicQueryBasePowerLineInput input) {
        BasePowerLineService bean = context.getBean(BasePowerLineService.class);
        return bean.queryBasePowerLineList(context, input);
    }

    @XText("天气")
    @XApiGet(anonymous = true)
    public XServiceResult test(XContext context, GetBaseDataInput input) {
//        BaseWeatherCloudServiceImpl bean = context.getBean(BaseWeatherCloudServiceImpl.class);
//        bean.weatherDataProcess(context, input.getKeyName());
//        WindPredictionHistoryCloudServiceImpl bean = context.getBean(WindPredictionHistoryCloudServiceImpl.class);
//        bean.windPredictionHistoryJob(context);
//        ThirdWindPowerGenerationCloudServiceImpl bean = context.getBean(ThirdWindPowerGenerationCloudServiceImpl.class);
//        bean.thirdWindPowerGenerationJob(context);
        return XServiceResult.OK;
    }

    @XText("风资源历史数据配置导入")
    @XApiGet
    public XServiceResult importWindPrediction(XContext context) {
        String fileName = "D:\\工作\\尚博信\\数据智能事业部\\零碳\\演示\\吉林\\新需求\\20240828\\data\\";
        Map<String, String> map = new HashMap<>();
        map.put("11.csv", "0191993ac6707650bc41b04b04ce9b62");
        map.put("12.csv", "0191993ac6707650bc41b04b04ce9b63");
        map.put("13.csv", "0191993ac6707650bc41b04b04ce9b64");
        map.put("14.csv", "0191993ac6707650bc41b04b04ce9b65");
        map.put("15.csv", "0191993ac6707650bc41b04b04ce9b66");
        map.put("16.csv", "11d04d59195746f48e14e149969940e5");
        map.put("17.csv", "133dae9b74034bab8c0f96a2878c41aa");
        map.put("18.csv", "8aa54645c3e34977ba3d121325881843");
        map.put("20.csv", "c0e6e7a0163f4e75a6e5e05627c0731a");
        map.forEach((key, value) -> {
            EasyExcel.read(fileName + key, WindPredictionExcelData.class, new WindPredictionDataListener(context, value)).sheet().doRead();
        });
        return XServiceResult.OK;
    }

    @XText("实际风资源数据")
    @XApiGet
    public XServiceResult importWindPrediction2(XContext context) {
        String fileName = "D:\\工作\\尚博信\\数据智能事业部\\零碳\\演示\\吉林\\新需求\\20240919\\导入实际数据.xlsx";
        EasyExcel.read(fileName, WindPredictionExcel2Data.class, new WindPredictionDataListener2(context)).sheet().doRead();
        return XServiceResult.OK;
    }

    @XText("风资源历史数据配置导入2")
    @XApiGet
    public XServiceResult importWindPrediction3(XContext context) {
        String fileName = "D:\\工作\\尚博信\\数据智能事业部\\零碳\\演示\\吉林\\新需求\\20240919\\result 3\\result 3";
        List<File> files = FileUtil.loopFiles(fileName);
        for (File file : files) {
            EasyExcel.read(file, ThirdApiWeatherExcelData.class, new ThirdApiWeatherDataListener2(context)).sheet().doRead();
        }
        return XServiceResult.OK;
    }

    @XText("天气历史数据导入")
    @XApiGet
    public XServiceResult importHistory(XContext context) {
        String fileName = "D:\\home\\result_w.csv";
        // 这里 需要指定读用哪个class去读，然后读取第一个sheet 文件流会自动关闭
        EasyExcel.read(fileName, ThirdApiWeatherExcelData.class, new ThirdApiWeatherDataListener(context)).sheet().doRead();
        return XServiceResult.OK;
    }
}